import Vue from 'vue';
import axios from './router/axios';
import VueAxios from 'vue-axios';
import App from './App';
import router from './router/router';
import './permission'; // 权限
import './error'; // 日志
import './cache';//页面缓存
import store from './store';
import {loadStyle} from './util/util'
import * as urls from '@/config/env';
import Element from 'element-ui';
import lazySelect from '@/components/lazy-select/lazy-select';
import AmapVue from '@amap/amap-vue';
import {
  iconfontUrl,
  iconfontVersion
} from '@/config/env';
import i18n from './lang'; // Internationalization
import './styles/common.scss';
import basicBlock from './components/basic-block/main';
import basicContainer from './components/basic-container/main';
import thirdRegister from './components/third-register/main';
import avueUeditor from 'avue-plugin-ueditor';
import website from '@/config/website';
import crudCommon from '@/mixins/crud';
import {select} from "./api/base/region";
import $ from 'jquery'
import layer from "layui-layer";

// 注册全局crud驱动
window.$crudCommon = crudCommon;
// 加载Vue拓展
Vue.use(router);
Vue.use(VueAxios, axios);
Vue.use(Element, {
  i18n: (key, value) => i18n.t(key, value)
});
AmapVue.config.version = '2.0';
AmapVue.config.key = 'cbb265e2a60bbbc04a52eec4eecdeb12';
AmapVue.config.plugins = [
  'AMap.ToolBar',
  'AMap.MoveAnimation',
  'AMap.MouseTool',
  'AMap.DistrictSearch'
];
Vue.use(AmapVue);
Vue.use(window.AVUE, {
  size: 'small',
  tableSize: 'small',
  calcHeight: 60,
  i18n: (key, value) => i18n.t(key, value)
});
// 注册全局容器
Vue.component('basicContainer', basicContainer);
Vue.component('basicBlock', basicBlock);
Vue.component('thirdRegister', thirdRegister);
Vue.component('avueUeditor', avueUeditor);
Vue.component('lazySelect', lazySelect);
// 加载相关url地址
Object.keys(urls).forEach(key => {
  Vue.prototype[key] = urls[key];
});
// 加载website
Vue.prototype.website = website;
// 动态加载阿里云字体库
iconfontVersion.forEach(ele => {
  loadStyle(iconfontUrl.replace('$key', ele));
});

Vue.config.productionTip = false;

Vue.prototype.regionFunction = (node, resolve)=> {
  let stop_level = 3;
  let level = node.level;
  let data = node.data || {}
  let code = data.code;
  let list = [];
  let callback = () => {
    resolve((list || []).map(ele => {
      return Object.assign(ele, {
        leaf: level >= stop_level
      })
    }));
  }
  if (level == 0) {
    select().then(res => {
      list = res.data.data;
      callback()
    })
  }
  if (level == 1) {
    select(code).then(res => {
      list = res.data.data;
      callback()
    })
  } else if (level == 2) {
    select(code).then(res => {
      list = res.data.data;
      callback()
    })
  } else if (level == 3) {
    select(code).then(res => {
      list = res.data.data;
      callback()
    })
  }else{
    list=[]
    callback()
  }
}
new Vue({
  router,
  store,
  i18n,
  render: h => h(App)
}).$mount('#app');
